#include "mex.h"
#include "math.h"

#define OK 0
#define ERROR -1
#define NARGIN 3
#define NARGOUT 1

int mxSubim2im(
        /* inputs */
        double * subimVec,
        int N,
        int picDim,
        
        /* outputs */
        double * pic
        ) {
    
    int n , m , nn , mm, k , t , subImLength, subImLength2;
    for ( n = 0 ; n < picDim * picDim ; n++ ) {
        pic[n] = 0;
    }
    subImLength = picDim - N + 1;
    subImLength2 = subImLength * subImLength; 
    /* building the image */
    
    for ( n = 0 ; n < N ; n++ ) {
        for ( m = 0 ; m < N ; m++ ) {
            k = n * N + m;
            t = 0;
            for ( nn = 0 ; nn < subImLength ; nn++ ) {
                for ( mm = 0 ; mm < subImLength ; mm++ ) {
                    pic[ ( n + nn ) * picDim + m + mm  ] = pic[ ( n + nn ) * picDim + m + mm  ] + subimVec[ k * subImLength2 + t ];
                    t++;
                }
            }
        }
    }
    /*
     * printf( " sortedIx = %d \n " , sortedIx[k] );
     */
    return OK;
    
}

void mexFunction( int nlhs, mxArray *plhs[],
        int nrhs, const mxArray *prhs[] ) {
    /* inputs */
    double * subimVec;
    int N;
    int picDim;
    
    /* outputs */
    double * pic;
    
    unsigned int dimsS[2];
    int ret_code;
    
    /* Check for proper number of arguments. */
    if(nrhs != NARGIN) {
        mexErrMsgTxt("9 inputs required.");
    } else if(nlhs > NARGOUT) {
        mexErrMsgTxt("Too many output arguments");
    }
    
    /* prhs - array of inputs */
    subimVec = mxGetPr(prhs[0]);
    N = (int) *mxGetPr(prhs[1]);
    picDim = (int) *mxGetPr(prhs[2]);
    
    dimsS[0] = picDim * picDim;
    dimsS[1] = 1;
    
    /* plhs - array of outputs */
    plhs[0] = mxCreateNumericArray(2, dimsS, mxDOUBLE_CLASS, mxREAL);
    pic = mxGetData(plhs[0]);
    
    /* call the calculating function */
    ret_code = mxSubim2im( subimVec , N , picDim , pic );
    if (ret_code==ERROR) {
        mexErrMsgTxt("error occured");
    }
}



